/*
 * StateNode.java
 *
 * Created on 7. říjen 2006, 12:13
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package misionarikanibalove;

import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author pirko
 */
public class StateNode {
    
    private State state;
    private StateNode parentState;
    
    private List<StateNode> nextStates = new LinkedList<StateNode>();
    
    /** Creates a new instance of StateNode */
    public StateNode(State state,StateNode parentState) {
        this.state = state;
        this.parentState = parentState;
    }
    
    public void fillUpNextStates() {
        State _1mis = _1misionar();
        if (null != _1mis && !pathContainsState(_1mis))
            getNextStates().add(new StateNode(_1mis,this));
        State _2mis = _2misionari();
        if (null != _2mis && !pathContainsState(_2mis))
            getNextStates().add(new StateNode(_2mis,this));
        State _1kan = _1kanibal();
        if (null != _1kan && !pathContainsState(_1kan))
            getNextStates().add(new StateNode(_1kan,this));
        State _2kan = _2kanibalove();
        if (null != _2kan && !pathContainsState(_2kan))
            getNextStates().add(new StateNode(_2kan,this));
        State _1ku1 = _1ku1();
        if (null != _1ku1 && !pathContainsState(_1ku1))
            getNextStates().add(new StateNode(_1ku1,this));
        
    }
    
    public void printPath(String toPrint) {
        if (parentState != null)
            parentState.printPath(getState().toString() + "\n" + toPrint);
        else
            System.out.println(getState().toString() + "\n" + toPrint);
    }
    
    public boolean pathContainsState(State state) {
        if (state.equals(getState())) 
            return true;
        else if (parentState == null) 
            return false;        
        else
            return parentState.pathContainsState(state);
    }
    
    
    private State _1misionar() {
        State result = new State();
        result.setBoatAtStart(getState().isBoatAtEnd());
        result.setStartKan(getState().getStartKan());
        result.setEndKan(getState().getEndKan());
        if (getState().isBoatAtStart()) {
            result.setStartMis(getState().getStartMis()-1);
            result.setEndMis(getState().getEndMis()+1);
        } else {
            result.setEndMis(getState().getEndMis()-1);
            result.setStartMis(getState().getStartMis()+1);
        }
        return result.isOk() ? result : null;
    }
    
    private State _2misionari() {
        State result = new State();
        result.setBoatAtStart(getState().isBoatAtEnd());
        result.setStartKan(getState().getStartKan());
        result.setEndKan(getState().getEndKan());
        if (getState().isBoatAtStart()) {
            result.setStartMis(getState().getStartMis()-2);
            result.setEndMis(getState().getEndMis()+2);
        } else {
            result.setEndMis(getState().getEndMis()-2);
            result.setStartMis(getState().getStartMis()+2);
        }
        return result.isOk() ? result : null;
    }
    
    private State _1kanibal() {
        State result = new State();
        result.setBoatAtStart(getState().isBoatAtEnd());
        result.setStartMis(getState().getStartMis());
        result.setEndMis(getState().getEndMis());
        if (getState().isBoatAtStart()) {
            result.setStartKan(getState().getStartKan()-1);
            result.setEndKan(getState().getEndKan()+1);
        } else {
            result.setEndKan(getState().getEndKan()-1);
            result.setStartKan(getState().getStartKan()+1);
        }
        return result.isOk() ? result : null;
    }
    
    private State _2kanibalove() {
        State result = new State();
        result.setBoatAtStart(getState().isBoatAtEnd());
        result.setStartMis(getState().getStartMis());
        result.setEndMis(getState().getEndMis());
        if (getState().isBoatAtStart()) {
            result.setStartKan(getState().getStartKan()-2);
            result.setEndKan(getState().getEndKan()+2);
        } else {
            result.setEndKan(getState().getEndKan()-2);
            result.setStartKan(getState().getStartKan()+2);
        }
        return result.isOk() ? result : null;
        
    }
    
    private State _1ku1() {
        State result = new State();
        result.setBoatAtStart(getState().isBoatAtEnd());
        if (getState().isBoatAtStart()) {
            result.setStartKan(getState().getStartKan()-1);
            result.setEndKan(getState().getEndKan()+1);
            result.setStartMis(getState().getStartMis()-1);
            result.setEndMis(getState().getEndMis()+1);
        } else {
            result.setEndKan(getState().getEndKan()-1);
            result.setStartKan(getState().getStartKan()+1);
            result.setStartMis(getState().getStartMis()+1);
            result.setEndMis(getState().getEndMis()-1);
        }
        return result.isOk() ? result : null;
        
    }

    public List<StateNode> getNextStates() {
        return nextStates;
    }

    public State getState() {
        return state;
    }
    
}
